import React, { useState } from 'react';
import ReactDOM from 'react-dom';

const initialBreakValue = 5;
const initialSessionValue = 25;
let myInterval;
let audio;
  
const getDisplayTime = (time) => {
	if (time < 10) {
    return '0' + time;
  }
  return time;
}

const App = () => {
	const [on, setOn] = useState(true);
	const [displayTime, setDisplayTime] = useState(initialSessionValue * 60);
	const [breakValue, setBreakValue] = useState(initialBreakValue);
	const [sessionValue, setSessionValue] = useState(initialSessionValue);
  
  return (
  	<>
    <div className='clock'>
      <div id='title'>25 + 5 Clock</div>
      <div id='options'>
        <div className='navs'>
      		<span id='break-label'>Break Length</span>
    			<div className='nav'>
            <button className='btn' id='break-decrement'
              onClick={() => {
              if (breakValue > 1) {
                setBreakValue(breakValue-1);
              }
              }}
              disabled={!on}
              >↓</button>
            <span id='break-length'>{breakValue}</span>
            <button className='btn' id='break-increment'
              onClick={() => {
                if (breakValue < 60) {
                  setBreakValue(breakValue+1);
                }
              }}
              disabled={!on}
              >↑</button>
      			</div>
      		</div>
          <div className='navs'>
        		<span id='session-label'>Session Length</span>
      			<div className='nav'>
              <button className='btn' id='session-decrement'
                onClick={() => {
            			if (sessionValue > 1) {
              			setSessionValue(sessionValue-1);
            				setDisplayTime((sessionValue-1) * 60);
                  }
                }}
              	disabled={!on}
                >↓</button>
              <span id='session-length'>{sessionValue}</span>
        			<button className='btn' id='session-increment'
          			onClick={() => {
            			if (sessionValue < 60) {
              		setSessionValue(sessionValue+1);
           		 		setDisplayTime((sessionValue+1) * 60);
                  }
          			}}
          			disabled={!on}
          		>↑</button>
    				</div>
      		</div>
    	</div>
      <div id='timer-label'>Session</div>
      <div id='display'>
        <div id='time-left'>
          <span>{getDisplayTime(Math.floor(displayTime/60))} : {getDisplayTime(displayTime % 60)}</span>
        </div>
      </div>
      <div id='two-buttons'>
        <button id='start_stop'
          onClick={() => {
          	setOn(!on);
            let countDown = displayTime;
            if (on) {
              myInterval = setInterval(() => {
                setDisplayTime((t) => t-1);
                countDown -= 1;
                if (countDown === 0) {
                 	audio = new Audio(document.getElementById('beep').src)
            audio.play() 
                }
                if (countDown === -1) {
                  countDown = breakValue * 60;
                  setDisplayTime(countDown);
                }
                if (countDown < 60) {
                 	document.getElementById('time-left').style.backgroundColor='red'; 
                  document.getElementById('time-left').style.color='white';
                } else {
                  document.getElementById('time-left').style.backgroundColor='white';
                  document.getElementById('time-left').style.color='black';
                }
              }, 1000);
            } else {
              if (audio) {
                    audio.stop();
                  }
              clearInterval(myInterval);
            }
          }}
          >||</button>
        <button id='reset'
          onClick={() => {
      			setBreakValue(initialBreakValue);
            setSessionValue(initialSessionValue);
  					setDisplayTime(initialSessionValue * 60);
            setOn(true);
            if (myInterval) {
              clearInterval(myInterval);
            }
            if (audio) {
                    audio.stop();
                  }
          }}
          >O</button>
      </div>
    </div>
    <div className='audio-container'>
      <span>Created By Siddharth Mittal</span>
      <audio hidden>
        <source id='beep' src='https://raw.githubusercontent.com/freeCodeCamp/cdn/master/build/testable-projects-fcc/audio/BeepSound.wav'/>
      </audio>
    </div>
    </>
  );
}

ReactDOM.render(<App />, document.getElementById('r